comment %

LuTiN_NoIR keygenme
-------------------
Le keygenme effectue un hash MD5 du nom entr.
Cryptage (RSA) du serial entr avec la cl suivante:
  n= 2F774486FD3B97FFA559687F7F9D5335CA3D16FBB60C0019
  e= 65537= 10001 en hexa
Puis le serial crypt est compar avec le hash du nom.

Il suffit donc de dcrypter le hash MD5 du nom avec la cl prive pour trouver le bon serial:
n=p*q avec:
  p= 69EF193F0EC20A9E57B455DB
  q= 72B4BF519A43852C9F9C761B
donc d=e^(-1) mod (p-1)(q-1). On obtient:
  d= 2312552808E487A2F561E2BBEF5FB7275C2BD350491DB9A1

serial=hash_md5(nom)^d mod n

Rq: le keygen ne marche pas pour les noms dont le hash MD5 du nom commence par un zro.
%

.486P
Locals
jumps

include	md5.asm
include	rsa.asm

Extrn	DialogBoxParamA:PROC
Extrn	EndDialog:PROC
Extrn	ExitProcess:PROC
Extrn	GetDlgItemTextA:PROC
Extrn	GetModuleHandleA:PROC
Extrn	MessageBoxA:PROC
Extrn	PostMessageA:PROC
Extrn	RtlMoveMemory:PROC
Extrn	SendDlgItemMessageA:PROC
Extrn	lstrcpyn:PROC
Extrn	VirtualAlloc:PROC
Extrn	VirtualFree:PROC

.Model Flat , StdCall

;----------------------------------------------------------------------------------------------

.Data

IDD_DLG			equ 100
IDD_name		equ 1000
IDD_serial		equ 1001
IDD_about		equ 1002
IDD_exit		equ 1004

MB_APPLMODAL		equ 0h
MB_ICONINFORMATION	equ 40h
MB_OK			equ 0h

WM_CLOSE		equ 0010h
WM_COMMAND		equ 0111h
WM_INITDIALOG		equ 0110h
WM_LBUTTONDOWN		equ 201h
WM_NCLBUTTONDOWN        equ 0A1h
WM_SETTEXT		equ 000Ch

PAGE_READWRITE		equ 4
MEM_COMMIT		equ 1000h
MEM_DECOMMIT		equ 4000h

HTCAPTION		equ 2

hInst		dd 0

duser		db 'jB',0
noname		db 'Le nom doit faire au moins 5 lettres...',0
aname		db 50 dup (0)
md5_hash	db 30 dup (0)

serial		db 50 dup (0)
abouttxt	db "Keygenme par LuTiN_NoIR",13,10
		db "Protection: RSA190 / MD5",13,10
		db 13,10
		db "Keygen par jB",0
aboutcap	db "A Propos...",0

cctab	db	"0123456789ABCDEF"

RSA_d:	dw	12	; 190 bits/16
	db	023h,012h,055h,028h,008h,0E4h,087h,0A2h,0F5h,061h,0E2h,0BBh,0EFh,05Fh,0B7h,027h,05Ch,02Bh,0D3h,050h,049h,01Dh,0B9h,0A1h,0,0

RSA_n:	dw	12	; 190 bits/16
	db	02Fh,077h,044h,086h,0FDh,03Bh,097h,0FFh,0A5h,059h,068h,07Fh,07Fh,09Dh,053h,035h,0CAh,03Dh,016h,0FBh,0B6h,00Ch,000h,019h,0,0

;----------------------------------------------------------------------------------------------

.Code
 
Start:
	call    GetModuleHandleA,0
	mov     hInst, eax
	call    DialogBoxParamA, hInst, IDD_DLG, 0, offset Main_DlgProc, 0
	call	ExitProcess, eax
    
;----------------------------------------------------------------------------------------------

Main_DlgProc proc hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
	pushad
	cmp     [wmsg], WM_LBUTTONDOWN
	jz      main_movedialog
	cmp     [wmsg], WM_COMMAND		 
	jz      main_command
	cmp     [wmsg], WM_INITDIALOG	 
	jz      main_init
	cmp     [wmsg], WM_CLOSE		 
	jz      main_dlgdestroy
	popad
	xor     eax, eax
	ret

stopproc:
	popad
	mov	eax, 1
	ret

main_init:
	call	SendDlgItemMessageA, hwnd, IDD_name, WM_SETTEXT, 0, offset duser
	jmp	generator

main_command:
	cmp	word ptr [wparam],IDD_exit
	jz	main_dlgdestroy  
	cmp	word ptr [wparam],IDD_name
	jz	generator
	cmp	word ptr [wparam],IDD_about
	jz	main_msgabout
	jmp	stopproc
	
main_movedialog:
	mov	eax, lparam
	call	PostMessageA, hwnd, WM_NCLBUTTONDOWN, HTCAPTION, eax
	jmp	stopproc

main_dlgdestroy:
	call    EndDialog, hwnd, 0
	jmp	stopproc

main_msgabout:
	call	MessageBoxA, hwnd, offset abouttxt, offset aboutcap, MB_ICONINFORMATION OR MB_OK OR MB_APPLMODAL
	jmp	stopproc

Generator:
	call	GetDlgItemTextA,hwnd,IDD_name,offset aname,50
	cmp	eax, 5
	jae	computeserial
non:
	call	SendDlgItemMessageA, hwnd, IDD_serial, WM_SETTEXT, 0, offset noname
	jmp	stopproc

computeserial:

; Hash MD5 du nom, procdure crite par Lucifer48
	call	MD5_Compute, offset aname, eax

	call	lstrcpyn, offset md5_hash, eax, 17

	call	RSA_PRIVATE_ENCRYPT, offset RSA_d, offset RSA_n, offset md5_hash, offset md5_hash, 16
	call	hex2strhex, offset md5_hash, offset serial
	call	SendDlgItemMessageA, hwnd, IDD_serial, WM_SETTEXT, 0, offset serial
	jmp	stopproc

Main_DlgProc    endp

;----------------------------------------------------------------------------------------------

; Conversion du bignum obtenu aprs le dcryptage en chaine de caractres
hex2strhex	proc source:DWORD, dest:DWORD
	mov	esi, source
	mov	edi, dest
	movzx	ecx, word ptr[esi]
	add	ecx, ecx
	inc	esi
	inc	esi
@@l1:	xor	eax, eax
	lodsb	
	mov	bl, al
	and	ebx, 15
	shr	eax, 4
	mov	al, cctab[eax]
	mov	ah, cctab[ebx]
	stosw
	dec	ecx
	jg	@@l1
	and	byte ptr[edi], 0
	ret
hex2strhex	endp

End Start